<?
Uses("Minitemplate");

// Domylny zbir znakw dla tekstu rdowego
define("DefaultCode","w");

// Funkcja zwraca tekst $st skonwertowany ze zbioru znakw $from do zbioru $to.
// Oto moliwe wartoci tego parametru.
// w[indows] - windows-1251
// k[oi8-r]  - koi8-r
// m[ac]     - x-mac-cyryllic
// i[so]     - iso-8859-5
// Uwaga: nawiasy kwadratowe zawieraj opcjonalne znaki.
// Funkcja jest bardzo uyteczna. Poniewa najczciej suy do zmiany
// listw, dodaem j do tego moduu.
function EncodeString($st,$to,$from=DefaultCode)
{ // Pozostaw tylko pierwszy znak
  $from=strtolower(substr($from,0,1));
  $to=strtolower(substr($to,0,1));
  // Wykorzystanie wbudowanej funkcji PHP
  return convert_cyr_string($st,$from,$to);
}

// Ustawienie wartoci parametru Content-type w zalenoci od nazwy zbioru znakw.
global $CoderCharset;
$CoderCharset["w"]="windows-1251";
$CoderCharset["i"]="iso-8859-5";
$CoderCharset["k"]="koi8-r";
$CoderCharset["m"]="x-mac-cyrillic";

// Znacznik rozdzielajcy tre listu od nagwkw (na przykad From).
define("MailDivider","~StartOfMail");
// Wysya list $msg do adresata $to, kodujc go w zbiorze znakw $encTo.
// Ustawia pole zbioru znakw i poprawnie przetwarza nazwy adresowe (jeli
// podano To: Bill, powoduje zamian na To: Bill<bill@provider.com>".
// W systemie Win32 list nie jest wysyany, ale za to powstaje specjalny
// plik z treci listu. List musi zawiera nagwki i ciao oddzielone
// znacznikiem ~StartOfMail.
function SendMail($to,$msg,$encTo=DefaultCode,$encFrom=DefaultCode)
{ global $CodersCharset;
  // Kodowanie tekstu
  $msg=EncodeString($msg,$encTo,$encFrom); // ciao listu
  $head="";                                // nagwki
  // Jeli s nagwki, wydobd je.
  if(strpos($mail,MailDivided)!==false) {
    $regs=split(MailDivider."\r?\n?",$msg,2); // ciao i nagwki
    $head=trim($regs[0]);
    $msg=$regs[1];
  }
  // Przetworzenie nagwkw. Rozbicie ich na wiersze.
  if($head) $Lines=split("[\r\n]+",$head); else $Lines=array();
  $HasContType=0; // Liczba nagwkw Content-type
  $chs="charset=$CoderCharset[$encTo]";
  $subject="";
  for($i=0; $i<count($Lines); $i++) {
    $l=&$Lines[$i];
    // Okrela aktualny zbir znakw. Z tego powodu sprawdza si, czy istnieje
    // nagwek Content-type. Jeli tak, modyfikuje go. Dodaje ten nagwek
    // na pocztku i na kocu listu.
    if(eregi("^Content-type:",$l)) {
      if(eregi("charset *=",$l))
        $l=eregi_replace("charset *= *[^;,\n]+",$chs,$l);
      else
        $l.="; $chs";
      $HasContType++;
    }
    // Sprawdzanie wartoci pola "to" w licie. Mona tam znale nazw odbiorcy.
    // Jeli si tam znajduje, dodajemy j do adresu.
    if(eregi("^to:([^\r\n]*)",$l,$regs)) {
      $to=trim($regs[1])." <$to>";
      $l="";
    }
    // Sprawdzenie nagwka Subject. W pewnych wersjach PHP przekazanie pustego
    // drugiego parametru do funkcji mail() prowadzi do nieprzewidzianych wynikw.
    // Rozwizujemy ten problem, okrelajc warto Subject dla listu
    if(eregi("^subject:([^\r\n]*)",$l,$regs)) {
      $subject=trim($regs[1]);
    }
  }
  // Jeli nie ma nagwka Content-type, dodajemy go na kocu
  if(!$HasContType) $Lines[]="Content-type: text/plain; $chs";
  // Ponowne zczenie wierszy
  $head=ereg_replace("\n\n+","\n",join("\n",$Lines));

  // Wysanie listu
  $Result=@mail($to,$subject,$msg,$head)!=0;
  // W systemie Windows zapamitaj list w celach testowych
  if(getenv("COMSPEC")) {
    if(!@is_dir("debug")) mkdir("debug",0755);
    $f=fopen("debug/_debug_mail.txt","a+");
    fputs($f,"> to: $to\n");
    fputs($f,"$head\n--------\n");
    fputs($f,"$msg\n---------------------------------\n\n");
    fclose($f);
  }
  return $Result;
}
// ExpandTemplate()). Nastpnie konwertuje wynikowy tekst do zbioru
// znakw $encTo (zakadajc, e tekst znajduje si w zbiorze znakw $encFrom).// Funkcja PostMail() rozszerza szablon $msg, czynic dostpnymi zmienne
// Nastpnie wysya list pod adres $to. Jeli tekst msg zaczyna si od// z tablicy $Vars do tego szablonu (patrz opisy funkcji ExpandFile() i
// prefiksu file i nazwy pliku, szablon listu jest wczytywany z podanego
// pliku funkcj ExpandFile(). W przeciwnym razie $msg traktowany jest
// jako szablon.
function PostMail($to,$msg,$encTo=DefaultCode,$Vars=false,$encFrom=DefaultCode)
{ if(eregi("^file:(.*)(\n|\$)",$msg,$P))
    $Text=ExpandFile(trim($P[1]),$Vars);
  else
    $Text=ExpandTemplate($msg,$Vars);
  // Wysanie listu
  return SendMail($to,$msg,$encTo,$encFrom);
}
?>

